LSH512_Base Class Reference

LSH-384 and LSH-512 hash base class. More...

`#include <lsh.h>`

Inheritance diagram for LSH512_Base:

## Public Member Functions

unsigned int | BlockSize () const
| Provides the block size of the compression function.
unsigned int | DigestSize () const
| Provides the digest size of the hash.
unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance.
void | Restart ()
| Restart the hash.
void | Update (const byte *input, size_t size)
| Updates a hash with additional input.
void | TruncatedFinal (byte *hash, size_t size)
| Computes the hash of the current message.
std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm.
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object.
virtual byte * | CreateUpdateSpace (size_t &size)
| Request space which can be written into by the caller.
virtual void | Final (byte *digest)
| Computes the hash of the current message.
unsigned int | TagSize () const
| Provides the tag size of the hash.
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this hash.
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message.
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message.
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message.
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message.
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message.
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message.
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms.
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm.
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object.

## Static Public Attributes

static const int | BLOCKSIZE = 256
| Block size, in bytes.

## Detailed Description

LSH-384 and LSH-512 hash base class.

LSH512_Base is the base class for both LSH-384 and LSH-512

Since
  Crypto++ 8.6

Definition at line 134 of file lsh.h.

## Constructor & Destructor Documentation

## ~LSH512_Base()

virtual LSH512_Base::~LSH512_Base | ( |  | ) |

inline virtual

Definition at line 141 of file lsh.h.

## Member Function Documentation

## BlockSize()

unsigned int LSH512_Base::BlockSize | ( |  | ) | const

inline virtual

Provides the block size of the compression function.

Returns
  block size of the compression function, in bytes

BlockSize() will return 0 if the hash is not block based or does not have an equivalent block size. For example, Keccak and SHA-3 do not have a block size, but they do have an equivalent block size called rate expressed as `r`.

Reimplemented from HashTransformation.

Definition at line 143 of file lsh.h.

## DigestSize()

unsigned int LSH512_Base::DigestSize | ( |  | ) | const

inline virtual

Provides the digest size of the hash.

Returns
  the digest size of the hash.

Implements HashTransformation.

Definition at line 144 of file lsh.h.

## OptimalDataAlignment()

unsigned int LSH512_Base::OptimalDataAlignment | ( |  | ) | const

inline virtual

Provides input and output data alignment for optimal performance.

Returns
  the input data alignment that provides optimal performance

See also
  GetAlignment() and OptimalBlockSize()

Reimplemented from HashTransformation.

Definition at line 145 of file lsh.h.

## Restart()

void LSH512_Base::Restart | ( |  | ) |

virtual

Restart the hash.

Discards the current state, and restart for a new message

Reimplemented from HashTransformation.

## Update()

void LSH512_Base::Update | ( | const byte * | input,
|  | size_t | length
| ) |  |

virtual

Updates a hash with additional input.

Parameters

  input | the additional input as a buffer
  length | the size of the buffer, in bytes

Implements HashTransformation.

## TruncatedFinal()

void LSH512_Base::TruncatedFinal | ( | byte * | digest,
|  | size_t | digestSize
| ) |  |

virtual

Computes the hash of the current message.

Parameters

  digest | a pointer to the buffer to receive the hash
  digestSize | the size of the truncated digest, in bytes

TruncatedFinal() calls Final() and then copies digestSize bytes to digest. The hash is restarted the hash for the next message.

Precondition
  `COUNTOF(digest) <= DigestSize()` or `COUNTOF(digest) <= HASH::DIGESTSIZE` ensures the output byte buffer is a valid size.

Implements HashTransformation.

## AlgorithmProvider()

std::string LSH512_Base::AlgorithmProvider | ( |  | ) | const

virtual

Retrieve the provider of this algorithm.

Returns
  the algorithm provider

The algorithm provider can be a name like "C++", "SSE", "NEON", "AESNI", "ARMv8" and "Power8". C++ is standard C++ code. Other labels, like SSE, usually indicate a specialized implementation using instructions from a higher instruction set architecture (ISA). Future labels may include external hardware like a hardware security module (HSM).

Generally speaking Wei Dai's original IA-32 ASM code falls under "SSE2". Labels like "SSSE3" and "SSE4.1" follow after Wei's code and use intrinsics instead of ASM.

Algorithms which combine different instructions or ISAs provide the dominant one. For example on x86 `AES/GCM` returns "AESNI" rather than "CLMUL" or "AES+SSE4.1" or "AES+CLMUL" or "AES+SSE4.1+CLMUL".

Note
  Provider is not universally implemented yet.

Since
  Crypto++ 8.0

Reimplemented from Algorithm.

## Member Data Documentation

## BLOCKSIZE

const int LSH512_Base::BLOCKSIZE = 256

static

Block size, in bytes.

LSH_512 uses LSH512_MSG_BLK_BYTE_LEN for block size, which is 256

Definition at line 139 of file lsh.h.

The documentation for this class was generated from the following file:

- lsh.h